Create a shift template
curl --request POST \
--url https://app.ontime.hosai.app/api/shifts \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "<string>",
"startTime": "<string>",
"endTime": "<string>",
"workingHours": 123,
"unpaidBreakMinutes": 0,
"breakWindowStart": "<string>",
"breakWindowEnd": "<string>",
"gracePeriodMinutes": 0,
"halfDayCutoffHours": 123,
"weeklyOff": [
"<string>"
],
"autoCheckoutAfter": "<string>",
"otEligibleAfterMinutes": 0,
"otCapPerDayMinutes": 0,
"category": "G",
"sku": "<string>",
"type": "fixed",
"status": "draft",
"tags": [],
"allLocations": true,
"locationIds": [],
"effectiveFrom": "<string>",
"otMultiplierWeekday": 1.5,
"otMultiplierHolidayOff": 2,
"otApprovalThresholdMinutes": 120,
"workingDays": {
"mon": true,
"tue": true,
"wed": true,
"thu": true,
"fri": true,
"sat": true,
"sun": true,
"secondSatOff": true,
"fourthSatOff": true,
"restrictedHolidays": true
},
"punchSources": {
"biometricOffice": {
"enabled": true,
"hint": "<string>"
},
"mobileGpsSelfie": {
"enabled": true,
"hint": "<string>"
},
"mobileOtpFallback": {
"enabled": true,
"hint": "<string>"
},
"webWfh": {
"enabled": true,
"hint": "<string>"
},
"qrKiosk": {
"enabled": true,
"hint": "<string>"
},
"managerMarked": {
"enabled": true,
"hint": "<string>"
}
},
"lateDeduction": {
"afterCount": 0,
"fraction": 123
},
"notifications": []
}
'import requests
url = "https://app.ontime.hosai.app/api/shifts"
payload = {
"name": "<string>",
"startTime": "<string>",
"endTime": "<string>",
"workingHours": 123,
"unpaidBreakMinutes": 0,
"breakWindowStart": "<string>",
"breakWindowEnd": "<string>",
"gracePeriodMinutes": 0,
"halfDayCutoffHours": 123,
"weeklyOff": ["<string>"],
"autoCheckoutAfter": "<string>",
"otEligibleAfterMinutes": 0,
"otCapPerDayMinutes": 0,
"category": "G",
"sku": "<string>",
"type": "fixed",
"status": "draft",
"tags": [],
"allLocations": True,
"locationIds": [],
"effectiveFrom": "<string>",
"otMultiplierWeekday": 1.5,
"otMultiplierHolidayOff": 2,
"otApprovalThresholdMinutes": 120,
"workingDays": {
"mon": True,
"tue": True,
"wed": True,
"thu": True,
"fri": True,
"sat": True,
"sun": True,
"secondSatOff": True,
"fourthSatOff": True,
"restrictedHolidays": True
},
"punchSources": {
"biometricOffice": {
"enabled": True,
"hint": "<string>"
},
"mobileGpsSelfie": {
"enabled": True,
"hint": "<string>"
},
"mobileOtpFallback": {
"enabled": True,
"hint": "<string>"
},
"webWfh": {
"enabled": True,
"hint": "<string>"
},
"qrKiosk": {
"enabled": True,
"hint": "<string>"
},
"managerMarked": {
"enabled": True,
"hint": "<string>"
}
},
"lateDeduction": {
"afterCount": 0,
"fraction": 123
},
"notifications": []
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
startTime: '<string>',
endTime: '<string>',
workingHours: 123,
unpaidBreakMinutes: 0,
breakWindowStart: '<string>',
breakWindowEnd: '<string>',
gracePeriodMinutes: 0,
halfDayCutoffHours: 123,
weeklyOff: ['<string>'],
autoCheckoutAfter: '<string>',
otEligibleAfterMinutes: 0,
otCapPerDayMinutes: 0,
category: 'G',
sku: '<string>',
type: 'fixed',
status: 'draft',
tags: [],
allLocations: true,
locationIds: [],
effectiveFrom: '<string>',
otMultiplierWeekday: 1.5,
otMultiplierHolidayOff: 2,
otApprovalThresholdMinutes: 120,
workingDays: {
mon: true,
tue: true,
wed: true,
thu: true,
fri: true,
sat: true,
sun: true,
secondSatOff: true,
fourthSatOff: true,
restrictedHolidays: true
},
punchSources: {
biometricOffice: {enabled: true, hint: '<string>'},
mobileGpsSelfie: {enabled: true, hint: '<string>'},
mobileOtpFallback: {enabled: true, hint: '<string>'},
webWfh: {enabled: true, hint: '<string>'},
qrKiosk: {enabled: true, hint: '<string>'},
managerMarked: {enabled: true, hint: '<string>'}
},
lateDeduction: {afterCount: 0, fraction: 123},
notifications: []
})
};
fetch('https://app.ontime.hosai.app/api/shifts', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"orgId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"sku": "<string>",
"name": "<string>",
"tags": [
"<string>"
],
"allLocations": true,
"locationIds": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"effectiveFrom": "<string>",
"startTime": "<string>",
"endTime": "<string>",
"workingHours": 123,
"unpaidBreakMinutes": 0,
"breakWindowStart": "<string>",
"breakWindowEnd": "<string>",
"gracePeriodMinutes": 0,
"halfDayCutoffHours": 123,
"weeklyOff": [
"<string>"
],
"autoCheckoutAfter": "<string>",
"otEligibleAfterMinutes": 0,
"otCapPerDayMinutes": 0,
"otMultiplierWeekday": 9,
"otMultiplierHolidayOff": 9,
"otApprovalThresholdMinutes": 0,
"workingDays": {
"mon": true,
"tue": true,
"wed": true,
"thu": true,
"fri": true,
"sat": true,
"sun": true,
"secondSatOff": true,
"fourthSatOff": true,
"restrictedHolidays": true
},
"punchSources": {
"biometricOffice": {
"enabled": true,
"hint": "<string>"
},
"mobileGpsSelfie": {
"enabled": true,
"hint": "<string>"
},
"mobileOtpFallback": {
"enabled": true,
"hint": "<string>"
},
"webWfh": {
"enabled": true,
"hint": "<string>"
},
"qrKiosk": {
"enabled": true,
"hint": "<string>"
},
"managerMarked": {
"enabled": true,
"hint": "<string>"
}
},
"lateDeduction": {
"afterCount": 0,
"fraction": 123
},
"notifications": [
{
"label": "<string>",
"channelTarget": "<string>"
}
]
}Shifts
Create a shift template
Create a shift template
POST
/
api
/
shifts
Create a shift template
Authorizations
Issue keys in Settings → API. Send them as Authorization: Bearer ont_… (an X-Api-Key: ont_… header is also accepted). Session-cookie routes are used by the OnTime web apps and are shown for completeness.
Body
application/json
Available options:
G, M, E, N, F Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Available options:
G, M, E, N, F, FL Available options:
fixed, flexible, rotational, field, custom Available options:
draft, published Pattern:
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Required range:
x <= 10Required range:
x <= 10Required range:
-9007199254740991 <= x <= 9007199254740991Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Response
200 - application/json
Success
Pattern:
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Pattern:
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Available options:
G, M, E, N, F Available options:
G, M, E, N, F, FL Available options:
fixed, flexible, rotational, field, custom Available options:
draft, published Pattern:
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
-9007199254740991 <= x <= 9007199254740991Required range:
x <= 10Required range:
x <= 10Required range:
-9007199254740991 <= x <= 9007199254740991Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
⌘I